use warnings;
use strict;
use Test::More;

use POWER::Event::IO qw( :event );

my @exports
    = qw( io_wait )
    ;
my @not_exports
    = qw( )
    ;
my @exports_scalar
    = qw(
        ERR RESOLVED CONNECTED ACCEPTED IN OUT EOF SENT
        STREAM LISTEN UDP UDP_CONNECTED
        RESOLVING CONNECTING HANDLING
    )
    ;

plan +(@exports + @not_exports + @exports_scalar)
    ? ( tests       => @exports + @not_exports + @exports_scalar    )
    : ( skip_all    => q{This module doesn't export anything}       )
    ;

for my $export (@exports) {
    can_ok( __PACKAGE__, $export );
}

for my $not_export (@not_exports) {
    ok( ! __PACKAGE__->can($not_export) );
}

no strict 'refs';
for my $export (@exports_scalar) {
    ok( ${$export}, "\$$export" );
}

