use warnings;
use strict;
use Test::More tests => 4;
use Test::Exception;
use Test::MockModule;

use POWER::Utils::Resource;
use POWER::Event;
use POWER::Event::IO;


for (1 .. 10) {
    POWER::Event::IO->new({
        type        => $LISTEN,
        host        => '0.0.0.0',
        port        => 1234,
        cb          => \&listener,
        wait_for    => $ACCEPTED,
    })->close();
}

my $mem = MEM_used();
my $fd  = FD_used();

for (1 .. 10000) {
    POWER::Event::IO->new({
        type        => $LISTEN,
        host        => '0.0.0.0',
        port        => 1234,
        cb          => \&listener,
        wait_for    => $ACCEPTED,
    })->close();
}

if ($INC{'Devel/Cover.pm'}) {
ok(abs(MEM_used() - $mem) < 10000, 'memory');
} else {
ok(abs(MEM_used() - $mem) < 100, 'memory');
}

is(FD_used(),  $fd,  'fd');


my $io = POWER::Event::IO->new({
        type        => $UDP_CONNECTED,
        host        => '127.0.0.1',
        port        => 1234,
        cb          => sub {},
});
close $io->{fh};
for (1 .. 10) {
    eval {
        POWER::Event::IO->new({
            type        => $UDP_CONNECTED,
            host        => '127.0.0.1',
            port        => 1234,
            cb          => sub {},
        });
    };
    die "eval error: $@" if $@ !~ qr/you must do \$io->close/;
}

$mem = MEM_used();

for (1 .. 5000) {
    eval {
        POWER::Event::IO->new({
            type        => $UDP_CONNECTED,
            host        => '127.0.0.1',
            port        => 1234,
            cb          => sub {},
        });
    };
    die "eval error: $@" if $@ !~ qr/you must do \$io->close/;
}

if ($INC{'Devel/Cover.pm'}) {
ok(abs(MEM_used() - $mem) < 10000, 'memory');
} else {
ok(abs(MEM_used() - $mem) < 100, 'memory');
}

is(FD_used(),  $fd,  'fd');

